commit 38888c45da4414884a5424484f5db1ab951d9de6
Author: Jason Merrill <jason@redhat.com>
Date:   Tue Nov 10 18:02:04 2020 -0500

    dwarf2: Set DW_AT_declaration for undefined fns [PR97060]
    
    If DECL_INITIAL isn't set, we can't emit anything about the body of the
    function, so add the declaration attribute.
    
    gcc/ChangeLog:
    
            PR debug/97060
            * dwarf2out.c (gen_subprogram_die): It's a declaration
            if DECL_INITIAL isn't set.
    
    gcc/testsuite/ChangeLog:
    
            PR debug/97060
            * gcc.dg/debug/dwarf2/pr97060.c: New test.

diff --git a/gcc/dwarf2out.c b/gcc/dwarf2out.c
index f3cd6029b5a..1fa6b846317 100644
--- a/gcc/dwarf2out.c
+++ b/gcc/dwarf2out.c
@@ -22771,6 +22771,7 @@ gen_subprogram_die (tree decl, dw_die_ref context_die)
           available.
   */
   int declaration = (current_function_decl != decl
+		     || (!DECL_INITIAL (decl) && !origin)
 		     || class_or_namespace_scope_p (context_die));
 
   /* A declaration that has been previously dumped needs no
diff --git a/gcc/testsuite/gcc.dg/debug/dwarf2/pr97060.c b/gcc/testsuite/gcc.dg/debug/dwarf2/pr97060.c
new file mode 100644
index 00000000000..c07b9046d9a
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/debug/dwarf2/pr97060.c
@@ -0,0 +1,13 @@
+/* PR debug/97060 */
+/* { dg-do compile } */
+/* { dg-options "-g -dA" } */
+/* { dg-final { scan-assembler-times "DW_AT_declaration" 2 } } */
+
+extern int foo (unsigned int, unsigned int);
+
+int
+bar (void)
+{
+  foo (1, 2);
+  return 0;
+}

